# -*- coding: utf-8 -*-
# @Author  : Wenzhe Lu and Heng Qiao
# @Time    : 2022/7/26
# @Software: Python 3.9

"""
This file provides a sample of how to generate the measurement model and call our Sep-B&B algorithm to solve
l0-based problems
"""

from Gen_Measurement import gen_measurement
# from Gen_Sparse_Measurement import gen_sparse_measurement
from Sep_BB import sep_bb


# Generate signals (with joint support), measurements and the measurement matrix
a, y, x, a_tilde, r, support = gen_measurement(m=60, n=300, l=10, k=5, delta=5, p=[0.5, 0.5, 0.75, 1, 1], var_w=1)
print(support)

# Generate signals (with joint support), measurements and the measurement matrix utilizing the sparse array idea
# a, y, x, a_tilde, r, support = gen_sparse_measurement(n=300, l=10, k=5, delta=5, p=[0.5, 0.5, 0.75, 1, 1], var_w=1)

# Recover the support by solving (Co-MIP) via Sep-B&B
num_of_nodes_bb, support_bb, time_bb = sep_bb(a_tilde, r, k=5, delta=5, u=5, lower_solver='cvx')
print(support_bb)
